#!/usr/bin/perl -w
#

# Plugin directory / home of utils.pm.
use lib "/usr/lib/nagios/plugins";
#use utils qw(%ERRORS &print_revision &support &usage);
use Getopt::Long qw(:config no_ignore_case bundling);
#use File::Basename;
#use Net::DNS;

use strict;

# Path to installed clamd binary.
my $iptable_cmd  = "sudo iptables";
my $debug_val = 0;  # Off unless -h arg
my $chaine = "mor-lan";
my $help_val=0;

sub show_help() {
    print <<END;

Usage: check_iptables_ppp [-v] [-h]
-h, --help
-v, --verbose
END
}

GetOptions (
    "h" => \$help_val, "help" => \$help_val,
    "v" => \$debug_val, "verbose" => \$debug_val
);

if ($help_val != 0) {
    &show_help;
    exit 0;
}

#recup nombre de drop internet out et in
if ($debug_val != 0) { print $iptable_cmd." -nvL -t nat";}
chomp(my $Result = `$iptable_cmd -nvL -t nat`);

if ($debug_val != 0) { print $Result;}
if ($Result eq ""){
    print "Check Iptables Tunnel PPP CRITIQUE : Pas de reponse\n";
    exit 2;
}
my $CodeSortie=2;
my $message1=" Regles NAT non trouvees";
if ($Result =~ /POSTROUTING/ and $Result =~ /ACCEPT/ and $Result =~ /84.55/ and $Result=~ /89.91/ and $Result =~ /212.194/ ) {
    $CodeSortie=0;
    $message1=" Regles NAT en service";
}
#Verifications

#test reponse boitier distant
my $message2="";
my $TimeRep=0;
#chomp(my $Result2 = `sudo nmap -sP 10.9.0.2`);
#if($Result2 =~ /1 host up/){
chomp(my $Result2 = `/usr/lib/nagios/plugins/check_udp -H 212.194.217.153 -p 500 -s ls -e ''`);
if($Result2 =~ /UDP OK/){
    $message2=" Acces Collecteur VPN OK";
     ($TimeRep) = $Result2 =~ /- (.*) second/;
}else{
    $CodeSortie=0;
    $message2=" Acces Collecteur VPN CRITIQUE";
}


my $message3="";
chomp(my $Result3 = `sudo tcpcheck 5 10.9.0.2:822`);
if($Result3 =~ /is alive/){
    $message3=" Connexion Arkoon port 822 OK";
}else{
    $CodeSortie=2;
    $message3=" Connexion Arkoon port 822 CRITIQUE";
}
#my $message3="";
#chomp(my $Result3 = `sudo ike-scan 10.9.0.1`);
#if($Result3 =~ /1 returned handshake/){
#    $message3=" Test IKE-SCAN OK";
#}else{
#    $CodeSortie=0;
#    $message3=" Test IKE-SCAN CRITIQUE";
#}

my $message4="";
chomp(my $Result4 = `sudo ip link show eth1`);
if($Result4 =~ /NO-CARRIER/){
    $message4=" ETH1 NON CONNECTE";
    $CodeSortie=2;
}else{
    $message4=" ETH1 OK";
}


if($CodeSortie == 0 ) {
    print "Check Iptables Tunnel PPP OK : $message4 $message1 $message2 ($TimeRep s) $message3\n";
}else{
    print "Check Iptables Tunnel PPP CRITIQUE : $message4 $message1 $message2 ($TimeRep s) $message3\n";
}
exit $CodeSortie;
