#! /usr/bin/perl
#use strict;
use Time::Local;
use Getopt::Long;

#verif prsence miroir
if (-e "/data/bureautique/diffusion/miroir-mcafee/SiteStat.xml") {
	my $fic="ok";
}else{
    print "Check Miroir MCAFEE CRITIQUE : Miroir NON INSTALLE\n";
    exit 2;
}

getoptions();

my $LibPer="";
unless ($tps_c) {
	$tps_c=172800;
	$LibPer=">48 Heures";
}else{
	$LibPer="> $tps_c secondes";
}

my $tps_w=$tps_c;

my $EtatFichier="";
my $CodeEtatFichier="";
my $EtatDate="";
my $CodeEtatDate="";
my $check="/usr/lib/nagios/plugins/check_file_age -w $tps_w -c $tps_c -f /data/bureautique/diffusion/miroir-mcafee/SiteStat.xml";
my $result=`$check`;
if( $result =~ /OK/) {
       ($EtatFichier) = $result =~ /is (.*) seconds/;
       $CodeEtatFichier="0";
}else{
       ($EtatFichier) = $result =~ /is (.*) seconds/;
       $CodeEtatFichier="2";
}
my $der_access=time()-$EtatFichier;
my $datemajfic=`date -d\@$der_access`;
chomp($datemajfic);
#print "$datemaj\n";


$result=`grep Status /data/bureautique/diffusion/miroir-mcafee/SiteStat.xml`;
#print "$result\n";
my ($DateSign) = $result =~ /CatalogVersion=\"(.*)\">/;
my $an=substr($DateSign,0,4);
my $mois=substr($DateSign,4,2);
my $j=substr($DateSign,6,2);
my $h=substr($DateSign,8,2);
my $m=substr($DateSign,10,2);
my $s=substr($DateSign,12,2);
my $datecalc=$j.".".$mois.".".$an." ".$h.":".$m.":".$s;
my ($mday,$mon,$year,$hour,$min,$sec) = split(/[\s.:]+/, $datecalc);
my $time = timelocal($sec,$min,$hour,$mday,$mon-1,$year);
#print $time,"\n",scalar localtime $time;
$DateSign=$time;
my $DateSignH=`date -d\@$DateSign`;
chomp($DateSignH);

$DateLimit=time()-$tps_c;
#print "DateSign=$DateSign DateLimit=$DateLimit";
if ($DateSign<$DateLimit) {
    $EtatDate= "Date Signatures $DateSignH DEPASSEE $LibPer";
    $CodeEtatDate="2";
}else{
    $EtatDate= "Date Signatures $DateSignH OK";
}

if($CodeEtatFichier eq "2") {
    print "Check Miroir MCAFEE CRITIQUE Date Fichier:$datemajfic PROBLEME REPLICATION $EtatDate\n";
    exit 2;
}
if($CodeEtatDate eq "2") {
    print "Check Miroir MCAFEE CRITIQUE Date Fichier:$datemajfic OK $EtatDate\n";
    exit 2;
}

print "Check Miroir MCAFEE  OK  Date Fichier:$datemajfic $EtatDate\n";
exit 0;


#------------------------------------------------------------------
sub getoptions {
    Getopt::Long::Configure('bundling');
    GetOptions(
       'h|help'            => \$opt_help,
       'c|tpscritique=s'     => \$tps_c,
    ) or do {
        print_usage();
        exit();
        };
    if($opt_help) {
        print_usage();
        exit();
    }
    sub print_usage {
      print <<EOB

Usage:
      check_miroir_macfee.pl [-c|--tpscritique secondes] 

EOB
    }
}

