#! /usr/bin/perl -w
#param base de donnes oracle
#require ("/usr/local/nagios/libexec/paramDB.pl") || die "Impossible d'ouvrir le fichier de configuration paramDB.pl";
#use strict;
#use Net::SNMP qw(:snmp oid_lex_sort);
use lib "/usr/lib/nagios/plugins";
use utils qw($TIMEOUT %ERRORS );
use Getopt::Long;
use vars qw($opt_h $opt_v $opt_u $opt_x $opt_m $opt_c $opt_w $opt_r $opt_U $opt_P );
$opt_h="";
my($debug, $check, $perf, $CodeHttp, $Tdns, $Ttcp, $Ttotal, $Taille, $Url,$Proxy);

my $ChaineAleat="";
my $message="";
@c=("A".."Z","a".."z",0..9);
$ChaineAleat= join("",@c[map{rand @c}(1..8)]);


sub print_help ();

#print "verif option\n";
GetOptions
    ("h"   => \$opt_h, "--help"         => \$opt_h,
     "u=s"   => \$opt_u, "--url=s" => \$opt_u,
     "m=s"   => \$opt_m, "--timeout=s" => \$opt_m,
     "c=s"   => \$opt_c, "--critique=s" => \$opt_c,
     "w=s"   => \$opt_w, "--warning=s" => \$opt_w,
     "x=s"   => \$opt_x, "--proxy=s" => \$opt_x,
     "v" => \$opt_v, "--verbose"       => \$opt_v,
     "N" => \$opt_n, "--authen"       => \$opt_n,
     "A=s" => \$opt_A, "--user=s"       => \$opt_A,
     "p=s" => \$opt_p, "--password=s"       => \$opt_p,
     "o=s" => \$opt_o, "--profil=s"       => \$opt_o,
     "r" => \$opt_r, "--no-redirect"       => \$opt_r);


#print "verif option\n";
$debug="";
if ($opt_v) {
    $debug=" -v --trace /usr/local/nagios/libexec/tracecurel.log --trace-time";
    $debug=" -v";
}
if (!$opt_A) {
	print "Usage: check_surf.pl -A user -p password -N [-v]\n";
	exit 0;
}
if (!$opt_p) {
	print "Usage: check_surf.pl -A user -p password -N [-v]\n";
	exit 0;
}

#recup domaine dans $o_domaine et force les elments recherches
my $domaine=`grep -E -v '^(#|;|\$|[ ]*#)' /etc/samba/smb.conf | grep "workgroup"`;
#print $domaine;
($resu) = $domaine =~ /workgroup = (.*)/;


if($opt_v) {print "domaine trouv ".$resu;}

if ( !defined($resu) ) {
	$domaine=`grep -E -v '^(#|;|\$|[ ]*#)' /etc/samba/smb.conf | grep "ldap suffix"`;
	#print $domaine;
	($resu) = $domaine =~ /ou=(.*),ou=domaines/;
	if ( !defined($resu) or $resu eq "" ) {
        	print "ERREUR RECHERCHE LDAP : Domaine introuvable dans configuration Samba\n";
        	exit 2;
	}
}
$domaine=$resu;
if ($opt_v) {print "Domaine : $domaine\n";}
if($opt_n) {
	#Verification authentification ntlm user psin.local-standard
	my $message="";
	my $CodeSortie=0;
	#integration domaine
	$result=`getent hosts|grep -i CDL | tail -n 1`;
	if ($opt_v) {print "$result\n";}
	if($result eq "") {
		print "Surf Authentifie non actif\n";
		exit 0;
	}
	my @CDL = split(/ /, $result);
	my $ECDL="ECDL:$CDL[0]";
	$result=`wbinfo -t`;
	if ($opt_v) {print "$result\n";}
	if($result =~ "succeeded") {
		$message="Domaine OK ";
	}else{
		$message="Domaine CRITIQUE $result";
		$CodeSortie=2;
	}

	#authentif ntlm
	if ($opt_v) {print "sudo ntlm_auth --username=$opt_A --domain=$domaine --password=$opt_p --request-nt-key\n";}
	$result=`sudo ntlm_auth --username=$opt_A --domain=$domaine --password=$opt_p --request-nt-key`;
	if ($opt_v) {print "$result\n";}
	if($result =~ "STATUS_NO_SUCH_USER") {
		$message=$message."Initialisation - User $opt_A non cree\n ";
		print $message;
		exit 1;
	}
	if($result =~ "NT_STATUS_OK: Success") {
		$message=$message."Auth NTLM OK ";
	}else{
		$message=$message."Auth NTLM CRITIQUE $result ";
		$CodeSortie=2;
	}
	#date fichier profile
	$result=`/usr/lib/nagios/plugins/check_file_age /etc/dansguardian/dansguardian0/common/filtergroupslist -C 100000 -w 6000 -c 6500`;
	if ($opt_v) {print "$result\n";}
	if($result =~ "FILE_AGE OK") {
		$message=$message."Fichier Profils OK ";
	}else{
		$message=$message."Fichier Profils CRITIQUE $result ";
		$CodeSortie=2;
	}
	#
	$message =~ s/\n//g;
	print $message." $ECDL\n";
	exit $CodeSortie;
}
#verification existence utilisateur local.psin-standard

$result=`wbinfo -u | grep $opt_A`;
if($result =~ "$opt_A") {
	$message="Utilisateur OK ";
}else{
	print "ERREUR : user $opt_A non cree";
	exit 2;
}


$opt_u =~ s/ChaineAleat/$ChaineAleat/;

#if ($opt_h) {
#    print_help();
#    exit $ERRORS{'OK'};
#	Getopt::Long::Configure('bundling');
#}

##################################################
#####      Verify Options
##
if (!$opt_u ) {
print "Option -u (--url) est obligatoire\n";
print_help();
exit $ERRORS{'OK'};
}
$Url=$opt_u;
$opt_u="$opt_u";

if(!$opt_x) {
  $opt_x="";
  $Proxy="Aucun";
}else{
  $Proxy=$opt_x;
  $opt_x="-x http://$opt_x";
}

if (!$opt_m) {
	$opt_m = 40;  #timeout defaut
}
if (!$opt_c) {
	$opt_c = 30;  #timeout defaut
}
if (!$opt_w) {
	$opt_w = 20;  #timeout defaut
}
my $uagent="-A Mozilla/5.0";
$perf="-w 'Perfdata:%{http_code}:%{time_namelookup}:%{time_connect}:%{time_total}:%{size_download}:%{url_effective}'";



#$check="curl --silent --no-sessionid -N -L -m $opt_m $debug $opt_x $opt_u $perf $uagent -o curl.log";
#$check="curl --retry 1 --proxy-ntlm --no-sessionid -N -m $opt_m -U $domaine\\$opt_A $debug $opt_x $opt_u $perf $uagent -o curl.log ";
#$check="curl --silent --retry 1  -H 'Pragma: no-cache' -N --proxy-ntlm -m $opt_m -U '$domaine\\$opt_A:$opt_p' $opt_x $opt_u $perf -v 1>>/dev/null 2>>/dev/null ";
#$check="curl --silent --retry 1  -H 'Pragma: no-cache' -N --proxy-ntlm -m $opt_m -U '$domaine\\$opt_A:$opt_p' $opt_x $opt_u $perf -v -o curl.log ";
$check="curl --silent --retry 1  -H 'Pragma: no-cache' -N --proxy-ntlm -m $opt_m -U '$domaine\\$opt_A:$opt_p' $opt_x $opt_u $perf -v ";

if($opt_v) {print $check;}
#exit;
$result=`$check 1>>/tmp/$ChaineAleat.log  2>&1`;
my $CodeRetour=$? >>8;
$result=`less /tmp/$ChaineAleat.log`;

#printf "child exited with value %d\n", $? >> 8;
#print $result;
if($opt_v) {print "RESULTAT:$result";}
#exit;
my $MessageDNS = "DNS OK";
#if ($result =~ /Couldn't resolve host/) {
if($result =~ "curl : commande introuvable") {
	my $inst = `sudo apt-get -y install curl`;
	$result=`$check 1>>/tmp/$ChaineAleat.log  2>&1`;
	$CodeRetour=$? >>8;
	$result=`less /tmp/$ChaineAleat.log`;
}
$result=`tail -n 1 /tmp/$ChaineAleat.log`;
my @Compteurs=split(":",$result);
$CodeHttp=$Compteurs[1];
$Tdns=$Compteurs[2];
$Tdns =~ s/,/./;
$Ttcp=$Compteurs[3];
$Ttcp =~ s/,/./;
$Ttotal=$Compteurs[4];
$Ttotal =~ s/,/./;
$Taille=$Compteurs[5];
#print "CodeHttp=$CodeHttp";
#if($CodeHttp eq "302" or $CodeHttp eq "301" and $opt_r ) {
if($CodeHttp eq "302" or $CodeHttp eq "301" ) {
	$CodeHttp="200";
}
#si code redirect 302 on suit la redirection
#if($CodeHttp eq "302" or $CodeHttp eq "301" ) {
#	$opt_u="--url '".$Compteurs[8].":".$Compteurs[9]."'";
#	$Url=$Compteurs[8].":".$Compteurs[9];
#	$check="curl --silent --no-sessionid -N -m $opt_m $debug $opt_x $opt_u $perf $uagent -o curl.log ";
#	if($opt_v) {print $check;}
#	$result=`$check`;
#	@Compteurs=split(":",$result);
#	$CodeHttp=$Compteurs[1];
#	$Tdns=$Compteurs[2];
#	$Tdns =~ s/,/./;
#	$Ttcp=$Compteurs[3];
#	$Ttcp =~ s/,/./;
#	$Ttotal=$Compteurs[4];
#	$Ttotal =~ s/,/./;
#	$Taille=$Compteurs[5];
#}
if ($CodeRetour eq "6") {
        $MessageDNS = "Erreur DNS";
	$CodeHttp="Erreur DNS";
}elsif($CodeRetour eq "7") {
	$CodeHttp = "Connexion au serveur Impossible";
}
if($CodeHttp eq "000") { $CodeHttp="Connexion TimeOut ou refusee";}
#for ($i=0;$i<=$#Compteurs;$i++)

#verif retour
if($result =~ "Authentication problem" or $result =~ "cache interdit" or $result =~ "reserve aux utilisateurs identifies") {
	print "CRITIQUE ERREUR AUTHENTIFICATION NTLM $MessageDNS Code HTTP retour : $CodeHttp Proxy:$Proxy Code Erreur:$CodeRetour\n";
	exit 2;
}

$result=`rm -f /tmp/$ChaineAleat.log`;

# { print ("$Compteurs[$i]\n");
#}
if($CodeHttp ne "200") {
	print "$MessageDNS Code HTTP retour : $CodeHttp Proxy:$Proxy Code Erreur:$CodeRetour Url:$Url\n";
	exit 2;
}

if($Ttotal >= $opt_c ) {
	print "$MessageDNS Temps total $Ttotal > $opt_c s (dns=$Tdns , tcp=$Ttcp , Taille:$Taille) Proxy:$Proxy Url:$Url|tdns=$Tdns,ttcp=$Ttcp,ttotal=$Ttotal\n";
	exit 2;
}
if($Ttotal >= $opt_w ) {
	print "$MessageDNS Temps total $Ttotal > $opt_w s (dns=$Tdns , tcp=$Ttcp , Taille:$Taille) Proxy:$Proxy Url:$Url|tdns=$Tdns,ttcp=$Ttcp,ttotal=$Ttotal\n";
	exit 1;
}else{
	print "$MessageDNS Temps total : $Ttotal s (dns=$Tdns , tcp=$Ttcp , Taille:$Taille) Proxy:$Proxy Url:$Url|tdns=$Tdns,ttcp=$Ttcp,ttotal=$Ttotal\n";
	exit 0;

}
sub print_help () {
    print "\nUsage:\n";
    print "   -u (--url)   URL a tester\n";
    print "   -v (--verbose)       debug file /usr/local/nagios/libexec/tracecurl.log\n";
    print "   -m   Timeout en seconde (30 par defaut)\n";
    print "   -x (--proxy)      indiquer le proxy hote:port\n";
    print "   -c (--critique)      temps critique en secondes defaut 25\n";
    print "   -w (--warning)      temps warning en secondes defaut 15\n";
    print "   -A (--user)      user\n";
    print "   -p (--password)      password\n";
}
exit 0;
